/*
 *  BJJEndianSwappers.h
 *  PowerSpectrumX
 *
 *  Created by B.J. Buchalter on 5/16/07.
 *  Copyright 2007 Metric Halo. All rights reserved.
 *
 */

#ifndef _BJJENDIANSWAPPERS_
#define _BJJENDIANSWAPPERS_
template <class T> inline T SwapData(const T&x);
template <class T> inline void SwapDataInPlace(T&x);

template <> inline BJJIndex SwapData(const BJJIndex&x)
{
	return OSSwapInt32(x);
}

template <> inline short SwapData(const short&x)
{
	return OSSwapInt16(x);
}

template <> inline void SwapDataInPlace( BJJIndex&x)
{
	x = OSSwapInt32(x);
}

template <> inline void SwapDataInPlace( short&x)
{
	x = OSSwapInt16(x);
}

template <> inline void SwapDataInPlace( BJJFadeMode&x)
{
	x = (BJJFadeMode)OSSwapInt32(x);
}



template <> inline void SwapDataInPlace( unsigned long&x)
{
	x = OSSwapInt32(x);
}

template <> inline void SwapDataInPlace( BJJBoolean&x)
{
	x = OSSwapInt32(x);
}

template <> inline void SwapDataInPlace( BJJRect&x)
{
	x.top = OSSwapInt32(x.top); 
	x.bottom = OSSwapInt32(x.bottom);
	x.left = OSSwapInt32(x.left);
	x.right = OSSwapInt32(x.right);
}

template <> inline void SwapDataInPlace( RGBColor&x)
{
	x.red = OSSwapInt16(x.red);
	x.green = OSSwapInt16(x.green);
	x.blue = OSSwapInt16(x.blue);
}

template <> inline void SwapDataInPlace( float&x)
{
unsigned long *xp = (unsigned long *)&x;

	*xp = OSSwapInt32(*xp);
}

template <> inline void SwapDataInPlace( double&x)
{
 uint64_t *xp = (uint64_t *)&x;

	*xp = OSSwapInt64(*xp);
}

#endif
